Index: /branches/2.2/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 1969)
+++ /branches/2.2/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 3018)
@@ -3347,17 +3409,11 @@
 		if($header->from[0]->personal != "")
 			$from = $header->from[0]->personal;
-		$ret_msg = $this->decode_string($from) . "--" . $subject . "--". gmdate("d/m/Y",$header ->udate)."--". $this->size_msg($header->Size) ."--". $flag;
+		$ret_msg['from'] = $this->decode_string($from); 
+		$ret_msg['subject'] = $subject; 
+		$ret_msg['udate'] = $header ->udate; 
+		$ret_msg['size'] = $header->Size; 
+		$ret_msg['flag'] = $flag; 
 		return $ret_msg;
 	}
-
-	function size_msg($size){
-		$var = floor($size/1024);
-		if($var >= 1){
-			return $var." kb";
-		}else{
-			return $size ." b";
-		}
-	}
-
 	function ob_array($the_object)
 	{
Index: /branches/2.2/expressoMail1_2/inc/gotodownload.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/gotodownload.php	(revision 1937)
+++ /branches/2.2/expressoMail1_2/inc/gotodownload.php	(revision 3018)
@@ -12,5 +12,5 @@
 	$msg_number = $_GET['msg_number'];
 	$idx_file = $_GET['idx_file'];
-	$newfilename = $_GET['newfilename'];
+	$newfilename = urldecode($_GET['newfilename']);
 	$msg_part = $_GET['msg_part'];
 	$msg_folder = $_GET['msg_folder'];
@@ -171,11 +171,30 @@
 			if (preg_match("#^".ini_get('session.save_path')."/(".$GLOBALS['phpgw']->session->sessionid."/)*[A-z]+_".$GLOBALS['phpgw']->session->sessionid."[A-z0-9]*(\.[A-z]{3,4})?$#",$strFileName))
 			{
-				readfile($strFileName);
-				exec("rm -f ".escapeshellcmd(escapeshellarg($strFileName)));
+				if (preg_match("#^".dirname( __FILE__ ) . '/../tmpLclAtt'."/source_#",$strFileName)) {
+					//avoid stuck request 
+					session_write_close(); 
+
+					//reset time limit for big files 
+					set_time_limit(0); 
+					ob_end_flush(); 
+
+					if ($fp = fopen ($strFileName, 'rb')) 
+					{ 
+						$bufferSize=1024; 
+						for ($i=$bufferSize; $i<=(filesize($strFileName)+$bufferSize); $i+=$bufferSize)  
+						{ 
+							echo fread($fp, $i); 
+							flush(); 
+						} 
+						fclose ($fp); 
+					} 
+					//readfile($strFileName); 	
+
+					exec("rm -f ".escapeshellcmd(escapeshellarg($strFileName)));
+				}
+				else 
+					if (preg_match("#^".dirname( __FILE__ ) . '/../tmpLclAtt'."/source_#",$strFileName)) {
+						readfile($strFileName);
+					}
 			}
-			else 
-				if (preg_match("#^".dirname( __FILE__ ) . '/../tmpLclAtt'."/source_#",$strFileName)) {
-					readfile($strFileName);
-				}
-	}
 ?>
Index: /branches/2.2/expressoMail1_2/inc/show_thumbs.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/show_thumbs.php	(revision 1040)
+++ /branches/2.2/expressoMail1_2/inc/show_thumbs.php	(revision 3018)
@@ -1,12 +1,5 @@
 <?php
-if(!isset($GLOBALS['phpgw_info'])){
-	$GLOBALS['phpgw_info']['flags'] = array(
-		'currentapp' => 'expressoMail1_2',
-		'nonavbar'   => true,
-		'noheader'   => true
-	);
-}
-require_once '../../header.inc.php';
 
+	require_once '../../header.session.inc.php'; 
 	$username = $_SESSION['phpgw_info']['expressomail']['user']['userid'];
 	$password = $_SESSION['phpgw_info']['expressomail']['user']['passwd'];
@@ -31,18 +24,16 @@
 	$image_mail = imap_fetchbody($mb, $msg_num, $msg_part, FT_UID);
 	$image = imap_base64($image_mail);
-	$image = imagecreatefromstring ($image);
-	
-	header("Content-Type: ".$file_type);
-	header("Content-Disposition: inline");
- 
-	$pic = $image;
-    if ($pic) {
-        $width = imagesx($pic);
-        $height = imagesy($pic);
-        $twidth = 160; # width of the thumb 160 pixel
-        $theight = $twidth * $height / $width; # calculate height
-        $thumb = imagecreatetruecolor ($twidth, $theight);
+	$pic = @imagecreatefromstring ($image);
+	if($pic !== FALSE) { 
+		header("Content-Type: ".$file_type); 
+		header("Content-Disposition: inline");
+		$width = imagesx($pic);
+		$height = imagesy($pic);
+		$twidth = 160; # width of the thumb 160 pixel
+		$theight = $twidth * $height / $width; # calculate height
+		$theight =  $theight < 1 ? 1 : $theight; 
+		$thumb = imagecreatetruecolor ($twidth, $theight);
 		imagecopyresized($thumb, $pic, 0, 0, 0, 0,$twidth, $theight, $width, $height); # resize image into thumb
 		imagejpeg($thumb,"",75); # Thumbnail as JPEG
-    }
+	}
 ?>
Index: /branches/2.2/expressoMail1_2/inc/class.ScriptS.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.ScriptS.inc.php	(revision 1352)
+++ /branches/2.2/expressoMail1_2/inc/class.ScriptS.inc.php	(revision 3018)
@@ -62,5 +62,6 @@
 			if(!$aux){
 				// Caso de erro, grava dentro da variável errstr;
-				$this->errstr = "O arquivo não foi criado";
+                                $this->errstr = "Error: file not created"; 
+                                return $this->errstr; 
 			}
 			// Mata a variavel;
@@ -71,5 +72,6 @@
 			if(!$aux){
 				// Caso de erro, grava dentro da variavel errstr;
-				$this->errstr = "O arquivo não foi ativado";
+                                $this->errstr = "Error: error to activate file"; 
+                                return $this->errstr; 
 			}
 			else{
@@ -84,9 +86,6 @@
 		$this->SieveS->close();
 			
-		if($this->rules){		
+		if($this->rules)
 			return $this->rules;
-		}else{
-			return $this->errstr;
-		}
 			
 	}
@@ -99,4 +98,5 @@
 	
 		$var_decode = rawurldecode($params['arfilter']);
+		$var_decode = preg_replace('/\n\./', '.', $var_decode);
 		
 		$narray  = explode("_end_",$var_decode);
Index: /branches/2.2/expressoMail1_2/inc/class.message_components.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.message_components.inc.php	(revision 1739)
+++ /branches/2.2/expressoMail1_2/inc/class.message_components.inc.php	(revision 3018)
@@ -112,11 +112,11 @@
                     $skip_next    = ($ftype == 'message/rfc822')?        true : false;
 
-                    if ($ftype == 'multipart/mixed' || $skip_part == true && $ftype == 'multipart/alternative' || $ftype == 'multipart/related' )
+		    if ($ftype == 'multipart/report' || $ftype == 'multipart/mixed' || $skip_part == true && $ftype == 'multipart/alternative' || ( $ftype == 'multipart/related' && strtolower( $parts[$p]->parts[0]->subtype ) == 'alternative' ) ) 
                     {
                         $n--;
                     }
                     else
-                    {
-                        $this->pid[$mid][$n]       = ($is_sub_part == false)? $i : ($sub_pid == '' ? '1' : $sub_pid).'.'.$i;
+		    {
+			$this->pid[$mid][$n]       = ($is_sub_part == false || $skip_part && $ftype == 'multipart/related' )? $i : ($sub_pid == '' ? '1' : $sub_pid).'.'.$i; 
                         $this->file_type[$mid][$n] = $ftype;
                         $this->encoding[$mid][$n]  = $encoding;
Index: /branches/2.2/expressoMail1_2/inc/class.SieveS.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.SieveS.inc.php	(revision 1149)
+++ /branches/2.2/expressoMail1_2/inc/class.SieveS.inc.php	(revision 3018)
@@ -178,5 +178,5 @@
 
 		//Verifica a conexao
-		if(!$this->socket){
+		if(!is_resource($this->socket)){ 
 			$this->errstr = "listscripts: sem conexão para o servidor $this->host";
 			return false;
@@ -187,5 +187,5 @@
 	
 		$said = $this->read();
-		while (!preg_match("/^OK/",$said) && !preg_match("/^NO/",$said)) {
+		while (is_resource($this->socket) && (!preg_match("/^OK/",$said) && !preg_match("/^NO/",$said))) { 
 	
 		    // Cyrus v1 script lines look like '"script*"' with the 
Index: /branches/2.2/expressoMail1_2/inc/show_img.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/show_img.php	(revision 1040)
+++ /branches/2.2/expressoMail1_2/inc/show_img.php	(revision 3018)
@@ -1,12 +1,5 @@
 <?php
-if(!isset($GLOBALS['phpgw_info'])){
-        $GLOBALS['phpgw_info']['flags'] = array(
-                'currentapp' => 'expressoMail1_2',
-                'nonavbar'   => true,
-                'noheader'   => true
-        );
-}
-require_once '../../header.inc.php';
 
+	require_once '../../header.session.inc.php'; 
 	header("Content-Type: image/jpeg");
 	if($_GET['msg_num'] && $_GET['msg_part'] && $_GET['msg_folder']) {
Index: /branches/2.2/expressoMail1_2/inc/show_embedded_attach.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/show_embedded_attach.php	(revision 1040)
+++ /branches/2.2/expressoMail1_2/inc/show_embedded_attach.php	(revision 3018)
@@ -1,11 +1,5 @@
 <?php
-if(!isset($GLOBALS['phpgw_info'])){
-        $GLOBALS['phpgw_info']['flags'] = array(
-                'currentapp' => 'expressoMail1_2',
-                'nonavbar'   => true,
-                'noheader'   => true
-        );
-}
-require_once '../../header.inc.php';
+
+	require_once '../../header.session.inc.php'; 
 
 	$username = $_SESSION['phpgw_info']['expressomail']['user']['userid'];
Index: /branches/2.2/expressoMail1_2/inc/hook_home.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/hook_home.inc.php	(revision 1402)
+++ /branches/2.2/expressoMail1_2/inc/hook_home.inc.php	(revision 3018)
@@ -11,6 +11,8 @@
 	$current_app = 'expressoMail1_2';
 	$current_name	 = 'Expresso Mail';
-	$preferences = $GLOBALS['phpgw']->preferences->read();
-        $_SESSION['phpgw_info']['user']['preferences']['expressoMail'] = $preferences['expressoMail'];
+	if(!$_SESSION['phpgw_info']['user']['preferences']['expressoMail']) { 
+		$preferences = $GLOBALS['phpgw']->preferences->read(); 
+		$_SESSION['phpgw_info']['user']['preferences']['expressoMail'] = $preferences['expressoMail'];
+	}
   	$homedisplay = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['mainscreen_showmail'];
 	if($homedisplay=='True')
Index: /branches/2.2/expressoMail1_2/inc/class.functions.inc.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.functions.inc.php	(revision 1572)
+++ /branches/2.2/expressoMail1_2/inc/class.functions.inc.php	(revision 3018)
@@ -116,6 +116,10 @@
             	$h = ord($c{0});   
 	            if ($h <= 0x7F || $h < 0xC2) {
-	            	$result .= $c;
-	            }
+			    // fixing curly brackets 
+			    if($h == 0x7B || $h == 0x7D) 
+				    $result .= "&#" . $h . ";"; 
+			    else 
+				    $result .= $c;
+		    }
 	           	else if ($h <= 0xDF) {
 	                $h = ($h & 0x1F) << 6 | (ord($c{1}) & 0x3F);
Index: /branches/2.2/expressoMail1_2/inc/class.phpmailer.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/class.phpmailer.php	(revision 1793)
+++ /branches/2.2/expressoMail1_2/inc/class.phpmailer.php	(revision 3018)
@@ -525,34 +525,16 @@
         for($i = 0; $i < count($this->to); $i++)
         {
-            if($this->valEm($this->to[$i][0]))
-            {
-                if(!$this->smtp->Recipient($this->to[$i][0]))  $bad_rcpt[] = $this->to[$i][0];
-            }
-            else
-            {
-                $errorx .= $this->to[$i][0] . ', ';
-            }
+		if(!$this->smtp->Recipient($this->to[$i][0]))
+			$bad_rcpt[] = $this->to[$i][0];
         }
         for($i = 0; $i < count($this->cc); $i++)
         {
-            if($this->valEm($this->cc[$i][0]))
-            {
-                if(!$this->smtp->Recipient($this->cc[$i][0])) $bad_rcpt[] = $this->cc[$i][0];
-            }
-			else
-            {
-                $errorx .= $this->cc[$i][0] . ', ';
-            }
+		if(!$this->smtp->Recipient($this->cc[$i][0]))
+			$bad_rcpt[] = $this->cc[$i][0];
         }
         for($i = 0; $i < count($this->bcc); $i++)
         {
-            if($this->valEm($this->bcc[$i][0]))
-            {
-                if(!$this->smtp->Recipient($this->bcc[$i][0])) $bad_rcpt[] = $this->bcc[$i][0];
-            }
-			else
-            {
-                $errorx .= $this->bcc[$i][0] . ', ';
-            }
+                if(!$this->smtp->Recipient($this->bcc[$i][0]))
+			$bad_rcpt[] = $this->bcc[$i][0];      
         }
         if($errorx != '')
@@ -728,31 +710,4 @@
     }
 
-    function valEm($email)
-    {
-        $mail_retorno = FALSE;
-        if ((strlen($email) >= 6) && (substr_count($email,"@") == 1) && (substr($email,0,1) != "@") && (substr($email,strlen($email)-1,1) != "@"))
-        {
-            if ((!strstr($email,"'")) && (!strstr($email,"\"")) && (!strstr($email,"\\")) && (!strstr($email,"\$")) && (!strstr($email," ")))
-            {
-                //testa se tem caracter .
-                if (substr_count($email,".")>= 1)
-                {
-                    //obtem a terminação do dominio
-                    $term_dom = substr(strrchr ($email, '.'),1);
-                    //verifica se terminação do dominio esta correcta
-                    if (strlen($term_dom)>1 && strlen($term_dom)<5 && (!strstr($term_dom,"@")) )
-                    {
-                        $antes_dom = substr($email,0,strlen($email) - strlen($term_dom) - 1);
-                        $caracter_ult = substr($antes_dom,strlen($antes_dom)-1,1);
-                        if ($caracter_ult != "@" && $caracter_ult != ".")
-                        {
-                            $mail_retorno = TRUE;
-                        }
-                    }
-                }
-            }
-        }
-        return $mail_retorno;
-    }
 
     /**
Index: /branches/2.2/expressoMail1_2/inc/show_user_photo.php
===================================================================
--- /branches/2.2/expressoMail1_2/inc/show_user_photo.php	(revision 1495)
+++ /branches/2.2/expressoMail1_2/inc/show_user_photo.php	(revision 3018)
@@ -1,11 +1,5 @@
 <?php
-if(!isset($GLOBALS['phpgw_info'])){
-	$GLOBALS['phpgw_info']['flags'] = array(
-		'currentapp' => 'expressoMail1_2',
-		'nonavbar'   => true,
-		'noheader'   => true
-	);
-}
-require_once '../../header.inc.php';
+
+	require_once '../../header.session.inc.php'; 
 
 
Index: /branches/2.2/expressoMail1_2/js/abas.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/abas.js	(revision 1994)
+++ /branches/2.2/expressoMail1_2/js/abas.js	(revision 3018)
@@ -113,4 +113,5 @@
 			return alternate_border(id_value);
 		var ID = id_value;
+		openTab.imapBox[ID] = current_folder;
 	}
 	td = document.createElement("TD");
@@ -124,5 +125,5 @@
 
 	td.setAttribute("align", "right");
-	td.onclick = function(){alternate_border(ID);};
+	td.onclick = function(){alternate_border(ID);resizeWindow()};
 	td.setAttribute("noWrap","true");
         td.alt = borderTitle;
@@ -152,20 +153,6 @@
 	div.style.display='';
 
-	var bar = document.getElementById("toolbar");
-	var offset = 0;
-	if(bar.style.visibility != 'hidden')
-		offset = bar.offsetHeight ? bar.offsetHeight :  bar.clientHeight;
-
-	div.style.height = document.body.clientHeight - offset - (is_ie ? 76 : 86);
 	div.style.overflow = "hidden";
 
-	if(!is_ie) {
-		var menuHidden = Element("folderscol").style.display == 'none' ? true : false;
-		var defaultWidth = document.body.clientWidth - 27;
-		if(!menuHidden)
-			defaultWidth -= Element("folderscol").offsetWidth;
-
-		div.style.width = defaultWidth;
-	}
 	Element("exmail_main_body").insertBefore(div,Element("footer_menu"));
 	alternate_border(ID);
@@ -213,25 +200,25 @@
 		if (body)
 		{
-				var save_link = Element("save_message_options_"+ID);
-				if (openTab.toPreserve[ID] == undefined)
-					openTab.toPreserve[ID] = false;
-				if ((! openTab.toPreserve[ID] && ! ID.toString().match("_r")) || ((body.contentWindow) == 'object' && body.contentWindow.document.designMode.toLowerCase() == 'on') && (save_link.onclick != ''))
-				{
-					var discard_msg = confirm(get_lang("Your message has not been sent. Discard your message?"), "");
-					if (!discard_msg)
-					{
-						Element("border_id_"+ID).onclick = function () { alternate_border(ID);};
-						return;
+			var save_link = Element("save_message_options_"+ID);
+			if (openTab.toPreserve[ID] == undefined)
+				openTab.toPreserve[ID] = false;
+			if ((! openTab.toPreserve[ID] && ! ID.toString().match("_r")) || ((body.contentWindow) == 'object' && body.contentWindow.document.designMode.toLowerCase() == 'on') && (save_link.onclick != ''))
+			{
+				var discard_msg = confirm(get_lang("Your message has not been sent. Discard your message?"), "");
+				if (!discard_msg)
+				{
+					Element("border_id_"+ID).onclick = function () { alternate_border(ID);};
+					return;
+				}
+				else
+				{
+					if (openTab.imapBox[ID] && openTab.imapUid[ID] && !openTab.toPreserve[ID]){
+						delete_msgs(openTab.imapBox[ID], openTab.imapUid[ID].toString(), 0)
+							openTab.toPreserve[ID] = false;
 					}
-					else
-					{
-						if (openTab.imapBox[ID] && !openTab.toPreserve[ID]){
-							delete_msgs(openTab.imapBox[ID], openTab.imapUid[ID].toString(), 0)
-							delete(openTab.imapBox[ID]);
-							openTab.toPreserve[ID] = false;
-							}
-							// Element('to_'+ID).focus(); It crash on IE
-					}
-				}
+					delete(openTab.imapBox[ID]);
+					// Element('to_'+ID).focus(); It crash on IE 
+				}
+			}
 		}
 	}
@@ -273,4 +260,5 @@
 	content = Element('content_id_' + ID);
 	content.parentNode.removeChild(content);
+	resizeWindow();
 	return true;
 }
Index: /branches/2.2/expressoMail1_2/js/messages_proxy.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/messages_proxy.js	(revision 1969)
+++ /branches/2.2/expressoMail1_2/js/messages_proxy.js	(revision 3018)
@@ -90,5 +90,5 @@
 	
 	messages_proxy.prototype.is_local_folder = function(folder) {
-		if(folder.indexOf("local_")==-1)
+		if(typeof(folder) == "undefined" || folder.indexOf("local_")==-1)
 			return false;
 		return true;
@@ -179,6 +179,5 @@
 	messages_proxy.prototype.proxy_move_messages = function (folder, msgs_number, border_ID, new_folder, new_folder_name) {
 		if (! folder || folder == 'null')
-			folder = Element("input_folder_"+msgs_number+"_r") ? Element("input_folder_"+msgs_number+"_r").value : get_current_folder();
-
+			folder = Element("input_folder_"+msgs_number+"_r") ? Element("input_folder_"+msgs_number+"_r").value : (openTab.imapBox[currentTab] ? openTab.imapBox[currentTab]:get_current_folder());
 		if ((this.is_local_folder(folder)) && (this.is_local_folder(new_folder))) { //Move entre pastas não locais...
 			if (folder == new_folder){
Index: /branches/2.2/expressoMail1_2/js/filters.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/filters.js	(revision 810)
+++ /branches/2.2/expressoMail1_2/js/filters.js	(revision 3018)
@@ -1,3 +1,3 @@
-var rules_limit = 300;
+var rules_limit = 3000;
 
 	function cfilterSh(){
@@ -67,14 +67,15 @@
 
 		this.showWindow(form);
-		filter.load_rules();
-		this.list_rules();			
-	
+		if ( filter.rulest.length > 0 ) 
+			this.list_rules(); 
+		else 
+			filter.load_rules(this.list_rules); 
 	}
 
 	cfilterSh.prototype.list_rules = function(){
-		if(filter.rulest.length == 0)
-			setTimeout("filters.mount_list()",2500);
-		else
-			this.mount_list();
+			if(filter.criticalError) 
+				return false; 
+			else 
+				filters.mount_list(); 
 	}
 
Index: /branches/2.2/expressoMail1_2/js/common_functions.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/common_functions.js	(revision 1899)
+++ /branches/2.2/expressoMail1_2/js/common_functions.js	(revision 3018)
@@ -35,11 +35,13 @@
 function resizeWindow(){
 
-	var bar = Element("toolbar");
-	var offset = 0;
-	if(bar.style.visibility != 'hidden') 
-		offset = (bar.offsetHeight ? bar.offsetHeight :  bar.clientHeight);	
-
-	var screenHeight = document.body.clientHeight ? document.body.clientHeight : document.body.offsetHeight;
-	var defaultHeight = screenHeight - offset;
+	var divScrollMain = Element("divScrollMain_"+numBox); 
+	var table_message = Element("table_message"); 
+	var content_folders = Element("content_folders"); 
+	var clientHeight = ((window.innerHeight ? window.innerHeight : document.body.offsetHeight) - 8); 
+	var clientWidth = window.innerWidth ? window.innerWidth : document.body.offsetWidth;
+
+	if(divScrollMain){ 
+		divScrollMain.style.height = (clientHeight - (findPosY(divScrollMain) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight))) + "px"; 
+	} 
 
 	if(typeof(BordersArray) != 'undefined') {
@@ -48,18 +50,20 @@
 			var div = Element("content_id_"+BordersArray[i].sequence);
 
-			// This comented code cause/avoid (!?) Firefox to stuck some request
-			if(div)
-//				div.setAttribute("style","height: "+parseInt(defaultHeight - 90)+"px;");
-				div.style.height = defaultHeight - 90;
-			if(div_scroll)
-//				div_scroll.setAttribute("style","height: "+parseInt(defaultHeight - 130)+"px;");
-				div_scroll.style.height = defaultHeight - 130;
-		}
-	}
-
-	if(Element('content_folders'))
-		Element('content_folders').style.height = defaultHeight - (is_ie ? 165 : 150);
-	if(Element("divScrollMain_"+numBox))
-		Element("divScrollMain_"+numBox).style.height 	= defaultHeight - (is_ie ? 111 : 110);
+			if(div){ 
+				div.style.height = (clientHeight - (findPosY(div) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight)+2)) + "px"; 
+				 div.style.width = (clientWidth - (findPosX(div)+10)) + "px"; 
+			} 
+			if(div_scroll){ 
+				div_scroll.style.height = (clientHeight - (findPosY(div_scroll) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight)+5)) + "px"; 
+				div_scroll.style.width = (clientWidth - (findPosX(div_scroll)+15)) + "px"; 
+			} 
+		} 
+	} 
+
+	if(content_folders){ 
+		var search_div = Element("search_div"); 
+		var contentFoldersY = findPosY(content_folders); 
+		content_folders.style.height = (clientHeight - (contentFoldersY + (contentFoldersY > findPosY(search_div) ? 0 : (search_div.clientHeight ? search_div.clientHeight : search_div.offsetHeight) + 5))) + "px"; 
+	} 
 }
 // END: FUNCTION RESIZE WINDOW
@@ -90,4 +94,6 @@
 // Translate words and phrases using user language from eGroupware.
 function get_lang(_key) {
+	if (typeof(_key) == 'undefined') 
+		return false; 
 	var key = _key.toLowerCase();
 	if(array_lang[key])
@@ -116,4 +122,5 @@
 	remove_className(tr_message, 'tr_msg_unread');
 	remove_className(tr_message, 'selected_msg');
+	Element("td_message_unseen_"+msg_number).innerHTML = "<img src ='templates/"+template+"/images/seen.gif' title='"+get_lang('Seen')+"'>"; 
 	connector.purgeCache();
 	return true;
@@ -131,4 +138,5 @@
 	remove_className(tr_message, 'selected_msg');
 	add_className(tr_message, 'tr_msg_unread');
+	Element("td_message_unseen_"+msg_number).innerHTML = "<img src ='templates/"+template+"/images/unseen.gif' title='"+get_lang('Unseen')+"'>"; 
 }
 
@@ -215,5 +223,5 @@
 	}
 	if(new_file_name)
-		params = "&newfilename="+new_file_name;
+		params = "&newfilename="+escape(new_file_name);
 	if(encoding)
 		params += "&encoding="+encoding;
@@ -862,4 +870,23 @@
 	}
 }
+
+function borkb(size){ 
+	kbyte = 1024; 
+	mbyte = kbyte*1024; 
+	gbyte = mbyte*1024; 
+	if (!size) 
+		size = 0; 
+	if (size < kbyte) 
+		return size + ' B'; 
+	else if (size < mbyte) 
+		return parseInt(size/kbyte) + ' KB'; 
+	else if (size < gbyte) 
+		if (size/mbyte > 100) 
+			return (size/mbyte).toFixed(0) + ' MB'; 
+		else 
+			return (size/mbyte).toFixed(1) + ' MB'; 
+	else 
+		return parseInt(size/gbyte).toFixed(1) + ' GB'; 
+} 
 
 function validate_date(date){
Index: /branches/2.2/expressoMail1_2/js/main.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/main.js	(revision 1989)
+++ /branches/2.2/expressoMail1_2/js/main.js	(revision 3018)
@@ -59,4 +59,5 @@
 		cExecute ("$this.db_functions.get_dropdown_contacts", save_contacts); //Save contacts needs preferences.
 		cExecute ("$this.imap_functions.get_folders_list&onload=true", update_menu);
+		cExecute ("$this.imap_functions.get_range_msgs2&folder=INBOX&msg_range_begin=1&msg_range_end="+preferences.max_email_per_page+"&sort_box_type=SORTARRIVAL&search_box_type=ALL&sort_box_reverse=1", handler_draw_box);
 		
 	}
@@ -320,6 +321,8 @@
 
 		
-		if(Element("border_id_" + id_msg_read)) 
-			alternate_border(id_msg_read);		
+		if(Element("border_id_" + id_msg_read)) {
+			alternate_border(id_msg_read);	
+			resizeWindow(); 	
+		}
 		else {
 			var border_id = create_border(msg_info.subject, id_msg_read);
@@ -393,10 +396,15 @@
 		if (box.childNodes.length == 0)
 		{
-			td_info = document.createElement("H3");
-			td_info.setAttribute("height", "25%");
+		        var tr_info = document.createElement("TR"); 
+                	var td_info = document.createElement("TD"); 
+                        td_info.setAttribute("colspan", "10"); 
 			td_info.setAttribute("background", "#FFF");
-			td_info.setAttribute("id", "msg_info");
+			tr_info.setAttribute("id", "msg_info");
 			td_info.align = "center";
-			td_info.innerHTML = get_lang("This mail box is empty");
+		        td_info.style.padding = "25px";                  
+               		td_info.style.fontWeight = "bold"; 
+                        td_info.style.fontSize = "11pt";   
+			td_info.innerHTML = get_lang("This mail box is empty");i
+			tr_info.appendChild(td_info); 
 			box.appendChild(td_info);
 		}
@@ -410,9 +418,15 @@
 			var box = Element("tbody_box");
 			table_element.appendChild(box);
-			
+			if (data[0].msg_folder != current_folder) // Bad request 
+                        	return false;
+
 			for (var i=0; i<data.length; i++){
-				var new_msg = this.make_tr_message(data[i], current_folder);				
-				_dragArea.makeDragged(new_msg, data[i].msg_number, data[i].subject, true);
-				eval(data[i].command);
+				var existent = document.getElementById(data[i].msg_number); 
+				if (!existent) 
+				{ 
+					var new_msg = this.make_tr_message(data[i], current_folder);                             
+					_dragArea.makeDragged(new_msg, data[i].msg_number, data[i].subject, true); 
+					eval(data[i].command); 
+				} 
 			}
 			if (! typeof(data.msgs_to_delete) == 'undefined')
@@ -633,6 +647,5 @@
 function move_msgs2(folder, msgs_number, border_ID, new_folder, new_folder_name,show_success_msg){
 	if (! folder || folder == 'null')
-		folder = Element("input_folder_"+msgs_number+"_r") ? Element("input_folder_"+msgs_number+"_r").value : get_current_folder();
-
+		folder = Element("input_folder_"+msgs_number+"_r") ? Element("input_folder_"+msgs_number+"_r").value : (openTab.imapBox[currentTab] ? openTab.imapBox[currentTab]:get_current_folder());
 	if(openTab.type[currentTab] == 1)
 		return move_search_msgs('content_id_'+currentTab,new_folder,new_folder_name);
@@ -1334,5 +1347,5 @@
 
 	// IM Module Enabled
-	if( window.parent.loadscript )
+	if( window.parent.loadscript && loadscript.autoStatusIM ) 
 	{
 		config_events( body.contentWindow.document, "onkeypress", loadscript.autoStatusIM );	
@@ -1429,4 +1442,5 @@
 
 function send_message_return(data, ID){
+    watch_changes_in_msg(ID); 
 
     var sign = false;
@@ -1702,4 +1716,5 @@
 function return_save(data,border_id,folder_name,folder_id,message_id)
 {
+	Element("send_button_"+border_id).style.visibility="visible"; 
 	var handler_delete_msg = function(data){ refresh(preferences.alert_new_msg); };
 
@@ -1839,5 +1854,4 @@
 		save_link.className = 'message_options_inactive';
 		watch_changes_in_msg(border_id);
-		Element("send_button_"+border_id).style.visibility="visible";
 		write_msg(get_lang('Your message was save as draft in folder %1.', lang_folder(folder_name)));
 	}		
@@ -1858,5 +1872,5 @@
 		sendButton.style.visibility="hidden";
 
-	if (openTab.imapBox[border_id]) //Gets the imap folder
+	if (openTab.imapBox[border_id] && openTab.type[border_id] != 6 && openTab.type[border_id] != 7) //Gets the imap folder 
 		var folder_id = openTab.imapBox[border_id];
 	else
@@ -2159,13 +2173,16 @@
 		if(!verify_session(data))
 			return;
-		if (get_current_folder() == 'INBOX'+cyrus_delimiter+trashfolder){
-			draw_paging(0);
-			kill_current_box();
-		}
 		tree_folders.getNodeById('INBOX'+cyrus_delimiter+trashfolder).alter({caption: get_lang("Trash")});
 		tree_folders.getNodeById('INBOX'+cyrus_delimiter+trashfolder)._refresh();
 		update_quota(get_current_folder());
-		if (data)
+		if (data){
 			write_msg(get_lang('Your Trash folder was empty.'));
+			if (get_current_folder() == 'INBOX'+cyrus_delimiter+trashfolder){
+				draw_paging(0);
+				kill_current_box();
+				Element('tot_m').innerHTML = 0;
+				Element('new_m').innerHTML = 0;
+			}
+		}
 		else
 			write_msg(get_lang('ERROR emptying your Trash folder.'));
@@ -2386,5 +2403,5 @@
 	else{
 		if(data == 'Post-Content-Length')
-			write_msg(get_lang('The size of this message has exceeded  the limit (%1B).',Element('upload_max_filesize').value));
+			write_msg(get_lang('The size of this message has exceeded  the limit (%1B).', preferences.max_attachment_size ? preferences.max_attachment_size : Element('upload_max_filesize').value));
 		else {	/*
 			* @author Rommel Cysne (rommel.cysne@serpro.gov.br)
Index: /branches/2.2/expressoMail1_2/js/connector.js
===================================================================
--- /branches/2.2/expressoMail1_2/js/connector.js	(revision 1965)
+++ /branches/2.2/expressoMail1_2/js/connector.js	(revision 3018)
@@ -340,4 +340,20 @@
 								if ( typeof data == 'undefined' )
 									data = oxmlhttp.responseText;
+								// Verify user session 
+								if(data && data.nosession){ 
+									// If hold session is setted, dont reload the page ... 
+									if(hold_session) { 
+										if(typeof(write_msg) == "function" && typeof(get_lang) == "function") 
+											write_msg(get_lang("your session could not be verified.")); 
+										else 
+											alert("your session could not be verified."); 
+									} 
+									else 
+										window.location.reload(); 
+
+									delete _thisObject.requests[id]; 
+									_thisObject.requests[id] = null; 
+									return false; 
+								} 
 								if(debug_controller) {
 									document.getElementById("debug_controller").innerHTML += oxmlhttp.responseText;
